KCharMacroExpander Class Referenceabstract

`#include <kmacroexpander.h>`

Inheritance diagram for KCharMacroExpander:

## Public Member Functions

| KCharMacroExpander (QChar c= '%')
Public Member Functions inherited from KMacroExpanderBase
| KMacroExpanderBase (QChar c= '%')
virtual | ~KMacroExpanderBase ()
void | expandMacros (QString &str)
bool | expandMacrosShellQuote (QString &str, uint &pos)
bool | expandMacrosShellQuote (QString &str)
void | setEscapeChar (QChar c)
QChar | escapeChar () const

## Protected Member Functions

virtual int | expandPlainMacro (const QString &str, uint pos, QStringList &ret)
virtual int | expandEscapedMacro (const QString &str, uint pos, QStringList &ret)
virtual bool | expandMacro (QChar chr, QStringList &ret)=0

## Detailed Description

Abstract base class for single char macro substitutors.

Use this instead of the functions in the KMacroExpander namespace if speculatively pre-filling the substitution map would be too expensive.

See KWordMacroExpander for a sample application.

Since
  3.3

Author
  Oswald Buddenhagen ossi@.nosp@m.kde..nosp@m.org

Definition at line 224 of file kmacroexpander.h.

## Constructor & Destructor Documentation

KCharMacroExpander::KCharMacroExpander | ( | QChar | c = `'%'` | ) |

inline

Constructor.

Parameters

  c | escape char indicating start of macros, or QChar::null for none

Definition at line 231 of file kmacroexpander.h.

## Member Function Documentation

int KCharMacroExpander::expandEscapedMacro | ( | const QString & | str,
|  | uint | pos,
|  | QStringList & | ret
| ) |  |

protected virtual

This function is called every time the escape char is found if it is not QChar::null.

It should determine whether the string starting at `pos` witin `str` is a valid macro and return the substitution value for it if so.

Parameters

  str | the input string
  pos | the offset within `str`. Note that this is the position of the occurrence of the escape char
  ret | return value: the string to substitute for the macro

Returns
  if greater than zero, the number of chars at `pos` in `str` to substitute with `ret` (i.e., a valid macro was found). if less than zero, subtract this value from `pos` (to skip a macro, i.e., substitute it with itself). zero requests no special action.

Reimplemented from KMacroExpanderBase.

Definition at line 443 of file kmacroexpander.cpp.

virtual bool KCharMacroExpander::expandMacro | ( | QChar | chr,
|  | QStringList & | ret
| ) |  |

protected pure virtual

Return substitution list `ret` for single-character macro `chr`.

Parameters

  chr | the macro to expand
  ret | return variable reference. It is guaranteed to be empty when expandMacro is entered.

Returns
  `true` iff `chr` was a recognized macro name

int KCharMacroExpander::expandPlainMacro | ( | const QString & | str,
|  | uint | pos,
|  | QStringList & | ret
| ) |  |

protected virtual

This function is called for every single char within the string if the escape char is QChar::null.

It should determine whether the string starting at `pos` within `str` is a valid macro and return the substitution value for it if so.

Parameters

  str | the input string
  pos | the offset within `str`
  ret | return value: the string to substitute for the macro

Returns
  if greater than zero, the number of chars at `pos` in `str` to substitute with `ret` (i.e., a valid macro was found). if less than zero, subtract this value from `pos` (to skip a macro, i.e., substitute it with itself). zero requests no special action.

Reimplemented from KMacroExpanderBase.

Definition at line 435 of file kmacroexpander.cpp.

The documentation for this class was generated from the following files:

- kmacroexpander.h
- kmacroexpander.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys